window.chartColors = {
	red: 'rgb(255, 99, 132)',
	orange: 'rgb(255, 159, 64)',
	yellow: 'rgb(255, 205, 86)',
	green: 'rgb(75, 192, 192)',
	blue: 'rgb(54, 162, 235)',
	purple: 'rgb(153, 102, 255)',
	grey: 'rgb(231,233,237)'
};

window.randomScalingFactor = function() {
	return (Math.random() > 0.5 ? 1.0 : -1.0) * Math.round(Math.random() * 100);
}

jQuery(document).ready( function($) {
          var ti=$('#title-pro').val();
          var dates=$('#dates-product').val();
          dates=dates.split(',');
          $('#showchart').click(function(){
                  $('p.loader').show();
                 var id_product=$('#id-pro').val();
                  var data = {action: 'Behzad_wp',id:id_product};
                 $.post(the_chart_url.chart_url, data, function(response){ 
                { 
                  response=$.parseJSON(response);  
                      var config = {
                                  type: 'line',
                                  data: {
                                      labels:dates,
                                      datasets: response
                                  },
                                  options: {
                                            responsive: true,
                                            title:{
                                                display:true,
                                                text:ti
                                            },
                                            tooltips: {
                                                mode: 'index',
                                                intersect: false,
                                            },
                                            hover: {
                                                mode: 'nearest',
                                                intersect: true
                                            },
                                            scales: {
                                                xAxes: [{
                                                    display: true,
                                                    scaleLabel: {
                                                        display: true,
                                                        labelString: 'date'
                                                    }
                                                }],
                                                yAxes: [{
                                                    display: true,
                                                    scaleLabel: {
                                                        display: true,
                                                        labelString: 'Value'
                                                    }
                                                }]
                                            }
                                        }
                                    };

                    var ctx = document.getElementById("canvas").getContext("2d");
                    window.myLine = new Chart(ctx, config);
                    $('p.loader').css({'display': 'none'});
                 }
            });
                 $(".remodal").remodal().open();
                        
        });


  });//end jquery